import org.apache.soap.Constants;
import java.net.URL;
import org.apache.soap.Fault;
import org.apache.soap.rpc.Call;
import org.apache.soap.rpc.Response;
import org.apache.soap.rpc.Parameter;

public class HelloWorldClient {
  static String DEFAULT_ENDPOINT = "http://localhost:8080/soap/servlet/rpcrouter";

  public static void main(String args[]) throws Exception {

    String endPoint = DEFAULT_ENDPOINT;

    //Process Arguments
    if (args.length == 1)
      endPoint = args[0];
    else if (args.length > 1)
      System.out.println("java HelloWorldClient [endpoint]");

      // Build the SOAP RPC request message using the Call object
      Call call = new Call();
      call.setTargetObjectURI("urn:HelloWorldService");
      call.setMethodName("getMessage");
      call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);

      // Create a URL object, which represents the endpoint
      URL url = new URL(endPoint);

      // Send the SOAP RPC request message using invoke() method
      Response resp = call.invoke(url, "");

      // Check the response.
      if (resp.generatedFault()) { // Error Occured
        Fault fault = resp.getFault();
        System.out.println("The Following Error Occured: ");
        System.out.println("  Fault Code   = " + fault.getFaultCode());  
        System.out.println("  Fault String = " + fault.getFaultString());
      } else { // Completed Successfully
        Parameter result = resp.getReturnValue();
        System.out.println(result.getValue());
      }
  }
}