import com.ibm.wsdl.xml.*;
import com.ibm.wsdl.extensions.soap.*;

import java.io.*;
import java.util.*;

import javax.wsdl.*;
import javax.wsdl.factory.*;

public class WSDL4JCreateSample {

  public static void main(String[] args) {
    try {
      Definition def = DefinitionFactory.newInstance().newDefinition();
      def.addNamespace("tns", "http://www.addressbook.com/definitions/AddressBookRemoteInterface");
      def.addNamespace("xsd1", "http://www.addressbook.com/schemas/AddressBookRemoteInterface");
      def.addNamespace("xsd", "http://www.w3.org/2001/XMLSchema");
      def.addNamespace("soap", "http://schemas.xmlsoap.org/wsdl/soap/");
      def.setTargetNamespace("http://www.addressbook.com/definitions/AddressBookRemoteInterface");

      // create import for schema
      Import importObject = def.createImport();
      importObject.setLocationURI("http://localhost:8080/test/wsdl/AddressBook-schema.xsd");
      importObject.setNamespaceURI("http://www.addressbook.com/schemas/AddressBookRemoteInterface");
      def.addImport(importObject);

      Part addressPart = def.createPart();
      addressPart.setName("result");
      addressPart.setTypeName(new QName("http://www.addressbook.com/schemas/AddressBookRemoteInterface", "Address"));

      Part personPart = def.createPart();
      personPart.setName("person");
      personPart.setTypeName(new QName("http://www.w3.org/2001/XMLSchema", "string"));

      Message iMessage = def.createMessage();
      iMessage.setUndefined(false);
      iMessage.setQName(new QName("http://www.addressbook.com/definitions/AddressBookRemoteInterface", "getAddressRequest"));
      iMessage.addPart(personPart);      
      def.addMessage(iMessage);

      Message oMessage = def.createMessage();
      oMessage.setUndefined(false);
      oMessage.addPart(addressPart);
      oMessage.setQName(new QName("http://www.addressbook.com/definitions/AddressBookRemoteInterface", "getAddressResponse"));
      def.addMessage(oMessage);

      Input input = def.createInput();
      input.setMessage(iMessage);

      Output output = def.createOutput();
      output.setMessage(oMessage);

      Operation operation = def.createOperation();
      operation.setUndefined(false);
      operation.setStyle(OperationType.REQUEST_RESPONSE);
      operation.setName("getAddress");
      operation.setInput(input);
      operation.setOutput(output);

      PortType portType = def.createPortType();
      portType.setUndefined(false);
      portType.addOperation(operation);
      portType.setQName(new QName("http://www.addressbook.com/definitions/AddressBookRemoteInterface", "AddressBook"));
      def.addPortType(portType);

      Binding binding = def.createBinding();
      binding.setUndefined(false);
      binding.setQName(new QName("http://www.addressbook.com/definitions/AddressBookRemoteInterface", "AddressBookBinding"));
      binding.setPortType(portType);
      SOAPBinding soapBinding = new SOAPBinding();
      soapBinding.setStyle("rpc");
      soapBinding.setTransportURI("http://schemas.xmlsoap.org/soap/http");
      binding.addExtensibilityElement(soapBinding);

      BindingOperation bindingOperation = def.createBindingOperation();
      bindingOperation.setName("getAddress");

      SOAPOperation soapOperation = new SOAPOperation();
      soapOperation.setStyle("rpc");
      soapOperation.setSoapActionURI("urn:AddressBook");
      bindingOperation.addExtensibilityElement(soapOperation);

      BindingInput bindingInput = def.createBindingInput();
      SOAPBody soapBody = new SOAPBody();
      soapBody.setUse("encoded");
      soapBody.setNamespaceURI("urn:AddressBook");
      Vector stylesVector = new Vector();
      stylesVector.addElement("http://schemas.xmlsoap.org/soap/encoding/");
      soapBody.setEncodingStyles(stylesVector);
      bindingInput.addExtensibilityElement(soapBody);
      bindingOperation.setBindingInput(bindingInput);

      BindingOutput bindingOutput = def.createBindingOutput();
      bindingOutput.addExtensibilityElement(soapBody);
      bindingOperation.setBindingOutput(bindingOutput);

      binding.addBindingOperation(bindingOperation);
      def.addBinding(binding);

      Port port = def.createPort();
      port.setName("AddressBookPort");
      port.setBinding(binding);

      SOAPAddress soapAddress = new SOAPAddress();
      soapAddress.setLocationURI("http://localhost:8080/wrox/servlet/rpcrouter");
      port.addExtensibilityElement(soapAddress);

      Service service = def.createService();
      service.addPort(port);
      service.setQName(new QName("http://www.addressbook.com/definitions/AddressBookRemoteInterface", "AddressBookService"));
      def.addService(service);

      try {
        WSDLWriter.writeWSDL(def, new FileWriter("c:\\jakarta-tomcat-3.2.1\\webapps\\wrox\\wsdl\\AddressBook.wsdl"));
      } catch (IOException io) {
        System.out.println("IO Exception : "+io);
      }
    } catch (WSDLException ex) {
      System.out.println("Exception - fault code : "+ex.getFaultCode());         
    }
  }
}