import com.ibm.wsdl.xml.*;
import javax.wsdl.*;
import org.xml.sax.*;
import java.util.*;

public class WSDL4JMessagesSample {

  public static void main(String[] args) {
    try {
      //WSDLReader.setImportDocuments(true);
      Definition def = WSDLReader.readWSDL(null, new InputSource("http://localhost:8080/wrox/wsdl/AddressBook.wsdl")); 
      Map messagesMap = def.getMessages();
      System.out.println("Number of messages found : "+messagesMap.size());
      Iterator iterator = messagesMap.keySet().iterator();
      while (iterator.hasNext()) {
        QName key = (QName)iterator.next();
        Message messageObject = (Message)messagesMap.get(key);
        System.out.println("Found Message.");
        System.out.println("\tMessage local name is : "+messageObject.getQName().getLocalPart());
        System.out.println("\tMessage namespace URI is : "+messageObject.getQName().getNamespaceURI());
        Map partsMap = messageObject.getParts();
        Iterator pIterator = partsMap.keySet().iterator();
        while (pIterator.hasNext()) {
          String pKey = (String)pIterator.next();
          Part partObject = (Part)partsMap.get(pKey);
          System.out.println("\tFound part.");
          System.out.println("\t\tPart name is "+partObject.getName());
          System.out.println("\t\tPart type is "+partObject.getTypeName());
          System.out.println("\t\tPart element name is "+partObject.getElementName());   
        }
      }
    } catch (WSDLException ex) {
      System.out.println("Exception - fault code : "+ex.getFaultCode());
    }
  }
}