import javax.wsdl.*;
import org.xml.sax.*;
import java.io.*;
import com.ibm.wsdl.xml.*;
import com.ibm.wsif.*;

public class WSIFSample {
  public static void main(String[] args) throws Exception {
    Definition def = WSDLReader.readWSDL(null, new InputSource("http://localhost:8080/wrox/wsdl/AddressBook.wsdl"));

    WSIFDynamicPortFactory dpf = new WSIFDynamicPortFactory(def);
    dpf.mapType( new QName("http://www.addressbook.com/schemas/AddressBookRemoteInterface", "Address"), Address.class);

    WSIFPort port = dpf.getPort();

    WSIFMessage input = port.createInputMessage();
    WSIFMessage output = port.createOutputMessage();
    WSIFMessage fault = port.createFaultMessage();

    WSIFPart inputPart = new WSIFJavaPart(java.lang.String.class, "Joe Smith");   
    input.setPart("person", inputPart);

    port.executeRequestResponseOperation("getAddress", input, output, fault);

    WSIFPart outputPart = output.getPart("result");
    Address address = (Address)outputPart.getJavaValue();
    System.out.println("Resulting address is:");
    System.out.println("\tStreet  : "+address.getStreet());
    System.out.println("\tCity    : "+address.getCity());
    System.out.println("\tZipcode : "+address.getZipcode());
  }
}