package com.provider2;

import com.wroxinsurance.Appointment;

import java.io.StringReader;

//JDOM packages
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;
import org.jdom.output.XMLOutputter;

public class Provider2Appointment implements Appointment {

    /** Creates new Provider2Appointment */
    public Provider2Appointment() {
    }

    public String getProviderDetails() {

  Element ProviderDetailsRoot = new Element("PROVIDER-DETAILS");
  ProviderDetailsRoot.setAttribute("PROVIDERID","2");
  ProviderDetailsRoot.addContent(new Element("NAME").setText("PROVIDER 2"));
    ProviderDetailsRoot.addContent(new Element("ADDR1").setText("Main Street"));
    ProviderDetailsRoot.addContent(new Element("ADDR2").setText("Suite 200"));
    ProviderDetailsRoot.addContent(new Element("CITY").setText("Cupertino"));
    ProviderDetailsRoot.addContent(new Element("STATE").setText("CA"));
    ProviderDetailsRoot.addContent(new Element("ZIPCODE").setText("94000"));
    ProviderDetailsRoot.addContent(new Element("PHONE").setText("408-111-2222"));
    ProviderDetailsRoot.addContent(new Element("FAX").setText("408-333-4444"));
    ProviderDetailsRoot.addContent(new Element("EMAIL").setText("info@provider2.com"));
    Document ProviderDetails = new Document(ProviderDetailsRoot);
    XMLOutputter outputter = new XMLOutputter("  ",true);
    return outputter.outputString(ProviderDetails);
  }

  public String getAppointmentSlots(String inputReq) {
    Element AppointmentsRoot = new Element("PROVIDER-APPOINTMENTS");
    AppointmentsRoot.setAttribute("PROVIDERID","2");

    //Appointment 1
    Element Appointment1 = new Element("APPOINTMENT");
    Appointment1.setAttribute("ID","B-1000");
    Appointment1.addContent(new Element("DATE").setText("5 NOV 2001"));
    Appointment1.addContent(new Element("TIME").setText("8:00 AM"));

    //Appointment 2
    Element Appointment2 = new Element("APPOINTMENT");
    Appointment2.setAttribute("ID","B-1001");
    Appointment2.addContent(new Element("DATE").setText("6 NOV 2001"));
    Appointment2.addContent(new Element("TIME").setText("5:00 PM"));

    //Appointment 3
    Element Appointment3 = new Element("APPOINTMENT");
    Appointment3.setAttribute("ID","B-1002");
    Appointment3.addContent(new Element("DATE").setText("7 NOV 2001"));
    Appointment3.addContent(new Element("TIME").setText("9:00 AM"));

    AppointmentsRoot.addContent(Appointment1);
    AppointmentsRoot.addContent(Appointment2);
    AppointmentsRoot.addContent(Appointment3);

    Document AppointmentSlots = new Document(AppointmentsRoot);
    XMLOutputter outputter = new XMLOutputter("  ",true);
    return outputter.outputString(AppointmentSlots);
  }

  public String reserveAppointment(String inputReq) {
    System.out.println("Received Appointment");
    System.out.println("--------------------");

    //Parse the Appointment Request
    try {
      SAXBuilder builder = new SAXBuilder();
      Document AppointmentReq = builder.build(new StringReader(inputReq));
      Element AppointmentReqRoot = AppointmentReq.getRootElement();
      String providerId = AppointmentReqRoot.getAttribute ("PROVIDERID").getValue();
      String patientId  = AppointmentReqRoot.getChild("PATIENTID").getText();
      String apptId = AppointmentReqRoot.getChild("APPOINTMENT-ID").getText();

      //Prepare Response
      Element AppointmentRespRoot = new Element("PROVIDER-APPOINTMENTRESPONSE");
      AppointmentRespRoot.setAttribute("PROVIDERID","2");
      AppointmentRespRoot.addContent(new Element("PATIENTID").setText(patientId));
      AppointmentRespRoot.addContent(new Element("APPOINTMENT-ID").setText(apptId));
      AppointmentRespRoot.addContent(new Element("STATUS").setText("OK"));
      Document AppointmentResponse = new Document(AppointmentRespRoot);
      XMLOutputter outputter = new XMLOutputter("  ",true);
      return outputter.outputString(AppointmentResponse);
    } catch (Exception e) {
      System.out.println("ERROR");
      return "ERROR";
    }
  }
}
