import java.net.*;
import java.util.*;

import org.apache.soap.Constants;
import org.apache.soap.Fault;
import org.apache.soap.SOAPException;
import org.apache.soap.rpc.Call;
import org.apache.soap.rpc.Parameter;
import org.apache.soap.rpc.Response;

public class ApacheSOAPClient {
  public static void main(String[] args) throws Exception {

    String endPoint = "http://localhost:8080/ccgw/GWXmlServlet";

    Call call = new Call();
    call.setTargetObjectURI("capeconnect:WroxCuisineService:WroxCuisineService");
    call.setMethodName("GetRecipesByCountry");
    call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);
    Vector params = new Vector();
    params.addElement(new Parameter("countryId", String.class, "2", null));
    call.setParams(params);

    // Invoke
    Response response = call.invoke(new URL(endPoint), 
                "capeconnect:WroxCuisineService:WroxCuisineService#GetRecipesByCountry");

    if (!response.generatedFault()) {
      System.out.println("SUCCESS");
      Parameter result = response.getReturnValue();
      System.out.println(result.getValue());
    } else {
      System.out.println(response.getFault().getFaultString());
    }
  }
}