// Java Program to access Web Service hosted in CapeConnect
import com.capeclear.soapdirect.SDRequest;
import com.capeclear.soapdirect.SDReply;
import com.capeclear.soapdirect.SDFault;
import com.capeclear.soapdirect.SDUtils;
import com.capeclear.soapdirect.SDUri;

import java.io.File;

public class CapeConnectClient {
  public static void main(String[] args) throws Exception {
    String gatewayURL;
    String hostname = "localhost";
    String port = "8080";
    gatewayURL = "http://" + hostname + ":" + port + "/ccgw/GWXmlServlet";

    String appName = "WroxCuisineService";
    String beanName = "WroxCuisineService";
    String opName = "GetAllRecipes";   // Get All Recipes

    SDUri targetURI = SDUtils.toTargetURI(appName, beanName, opName);
    SDRequest sdRequest = new SDRequest(targetURI);
    SDReply reply = sdRequest.invoke(gatewayURL);
    if (reply.isFault()) {
      SDFault fault = reply.getFault();
      System.out.println("SOAP Fault Occured");
      System.out.println("Fault Actor: " + fault.getFaultActor());
      System.out.println("Fault Code: " + fault.getFaultCode());
      System.out.println("Fault String: " + fault.getFaultString());
      System.out.println("Fault Detail: " + fault.getFaultDetail());
    } else {
      System.out.println("Message returned from server: " 
                         + reply.getString());
    }
  }
}