package com.wroxcuisine.ejb;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.rmi.RemoteException;
import javax.ejb.EJBException;
import javax.ejb.CreateException;

import javax.naming.*;
import java.util.*;
import java.sql.*;
import javax.sql.*;

// JDOM Packages
import org.jdom.input.*;
import org.jdom.output.*;
import org.jdom.*;

// XML Helpers
import com.wroxcuisine.xml.XMLGenerator;
import com.wroxcuisine.helpers.Recipe;
import com.wroxcuisine.helpers.Country;
import com.wroxcuisine.helpers.DirectoryService;

public class WroxCuisineServiceEJB implements SessionBean {
  private SessionContext ctx;

  public void setSessionContext(SessionContext context) 
          throws RemoteException, EJBException {
    ctx = context;
  }

  public void ejbActivate() throws RemoteException, EJBException {}

  public void ejbPassivate() throws RemoteException, EJBException {}

  public void ejbRemove() throws RemoteException, EJBException {}

  public void ejbCreate() 
          throws CreateException, EJBException, RemoteException {}

  public String GetAllCountries() {
    try {
      ArrayList countries = new ArrayList();

      InitialContext ctx = DirectoryService.getInitContext();
      DataSource ds = (DataSource) ctx.lookup("WroxCuisineDB");
      Connection conn = ds.getConnection();
      Statement st = conn.createStatement();
      ResultSet rs = st.executeQuery("SELECT * FROM COUNTRY");

      while (rs.next()) {
        Country c = new Country();
        c.setCountryId(rs.getInt("COUNTRYID"));
        c.setCountryName(rs.getString("COUNTRYNAME"));
        c.setCountryDesc(rs.getString("COUNTRYDESC"));
        countries.add(c);
      } 
      st.close();
      conn.close();

      return XMLGenerator.getAllCountriesXML(countries, true);

    } catch (Exception e) {
      throw new EJBException(e);
    } 
  } 

  public String GetRecipesByCountry(int countryId) {
    try {
      ArrayList recipes = new ArrayList();

      InitialContext ctx = DirectoryService.getInitContext();
      DataSource ds = (DataSource) ctx.lookup("WroxCuisineDB");
      Connection conn = ds.getConnection();
      Statement st = conn.createStatement();
      ResultSet rs = 
        st.executeQuery("SELECT * FROM RECIPE WHERE COUNTRYID = " 
                        + countryId);

      while (rs.next()) {
        Recipe r = new Recipe();
        r.setRecipeId(rs.getInt("RECIPEID"));
        r.setCountryId(rs.getInt("COUNTRYID"));
        r.setRecipeName(rs.getString("RECIPENAME"));
        r.setRecipeDesc(rs.getString("RECIPEDESC"));
        r.setRecipeIngredients(rs.getString("RECIPEINGREDIENTS"));
        r.setRecipeSteps(rs.getString("RECIPESTEPS"));
        recipes.add(r);
      } 
      st.close();
      conn.close();

      return XMLGenerator.getAllRecipesXML(recipes, true);
    } catch (Exception e) {
      throw new EJBException(e);
    } 
  } 

  public String GetAllRecipes() {
    try {
      ArrayList recipes = new ArrayList();

      InitialContext ctx = DirectoryService.getInitContext();
      DataSource ds = (DataSource) ctx.lookup("WroxCuisineDB");
      Connection conn = ds.getConnection();
      Statement st = conn.createStatement();
      ResultSet rs = st.executeQuery("SELECT * FROM RECIPE");

      while (rs.next()) {
        Recipe r = new Recipe();
        r.setRecipeId(rs.getInt("RECIPEID"));
        r.setCountryId(rs.getInt("COUNTRYID"));
        r.setRecipeName(rs.getString("RECIPENAME"));
        r.setRecipeDesc(rs.getString("RECIPEDESC"));
        r.setRecipeIngredients(rs.getString("RECIPEINGREDIENTS"));
        r.setRecipeSteps(rs.getString("RECIPESTEPS"));
        recipes.add(r);
      } 
      st.close();
      conn.close();

      return XMLGenerator.getAllRecipesXML(recipes, true);

    } catch (Exception e) {
      throw new EJBException(e);
    } 
  } 

  public String GetRecipeDetails(int recipeId) {
    try {

      Recipe r = new Recipe();

      InitialContext ctx = DirectoryService.getInitContext();
      DataSource ds = (DataSource) ctx.lookup("WroxCuisineDB");
      Connection conn = ds.getConnection();
      Statement st = conn.createStatement();
      ResultSet rs = 
        st.executeQuery("SELECT * FROM RECIPE WHERE RECIPEID = " 
                        + recipeId);

      while (rs.next()) {
        r.setRecipeId(rs.getInt("RECIPEID"));
        r.setCountryId(rs.getInt("COUNTRYID"));
        r.setRecipeName(rs.getString("RECIPENAME"));
        r.setRecipeDesc(rs.getString("RECIPEDESC"));
        r.setRecipeIngredients(rs.getString("RECIPEINGREDIENTS"));
        r.setRecipeSteps(rs.getString("RECIPESTEPS"));
      } 
      st.close();
      conn.close();

      return XMLGenerator.getRecipeXML(r, true);
    } catch (Exception e) {
      throw new EJBException(e);
    } 
  } 

  public String GetRandomRecipe() {
    try {

      int recipeCount = 0;
      InitialContext ctx = DirectoryService.getInitContext();
      DataSource ds = (DataSource) ctx.lookup("WroxCuisineDB");
      Connection conn = ds.getConnection();
      Statement st = conn.createStatement();
      ResultSet rs = 
        st.executeQuery("SELECT COUNT(*) AS RECIPECOUNT FROM RECIPE");

      if (rs.next()) {
        recipeCount = rs.getInt("RECIPECOUNT");
      } 
      st.close();
      conn.close();

      // Now we have the count
      Random rand = new Random();
      int recipeId = rand.nextInt(recipeCount);
      return this.GetRecipeDetails(recipeId);

    } catch (Exception e) {
      throw new EJBException(e);
    }
  }
}