package com.wroxcuisine.xml;

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import org.jdom.transform.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;

import java.io.*;

public class XSLTransform {

  private String xmlData = "";
  private String xslFileURL = "";
  private String transformedData = "";

  public XSLTransform() {}

  public void setXmlData(String xmlData) {
    this.xmlData = xmlData;
  }

  public String getXMLData() {
    return this.xmlData;
  }

  public void setXslFileURL(String xslFileURL) {
    this.xslFileURL = xslFileURL;
  }

  public String getTransformedData() throws JDOMException {
    try {

      SAXBuilder builder = new SAXBuilder();
      Document doc = builder.build(new StringReader(this.xmlData));


      Transformer transformer = TransformerFactory.newInstance()
      .newTransformer(new StreamSource(new File(this.xslFileURL)));

      JDOMResult out = new JDOMResult();
      transformer.transform(new JDOMSource(doc), out);
      Document outputDoc = out.getDocument();
      XMLOutputter xmloutputter = new XMLOutputter("  ", true);
      xmloutputter.setTextNormalize(true);
      return xmloutputter.outputString(outputDoc);

    } catch (Exception e) {
      throw new JDOMException("XSLT Transformation failed", e);
    }
  }

  public String transform(String xmlInput, File xslFileName) throws JDOMException {
    try {

      SAXBuilder builder = new SAXBuilder();
      Document doc = builder.build(new StringReader(xmlInput));

      Transformer transformer = TransformerFactory.newInstance()
      .newTransformer(new StreamSource(xslFileName));

      JDOMResult out = new JDOMResult();
      transformer.transform(new JDOMSource(doc), out);
      Document outputDoc = out.getDocument();
      XMLOutputter xmloutputter = new XMLOutputter("  ", true);
      xmloutputter.setTextNormalize(true);
      return xmloutputter.outputString(outputDoc);

    } catch (Exception e) {
      throw new JDOMException("XSLT Transformation failed", e);
    }
  }
}