import com.sap.mw.jco.*;

public class TryJco {
  JCO.Client myJcoclient = null;

  public int doJco() {
    try {
      // Create a client connection to SAP
      myJcoclient = JCO.createClient(
                  "777",                       // SAP client
                  "jmilbery",                  // userid
                  "*******",                   // password
                  "EN",                        // language
                  "meat.backsoft.com",         // host name
                  "00");                       // system number

      // Open the connection
      myJcoclient.connect();

      // Print the Connection Attributes
      JCO.Attributes attributes = myJcoclient.getAttributes();
      System.out.println("Connection attributes:\n" + 
               "----------------------\n" + attributes);
      // Create the input parameter list
      JCO.ParameterList input = JCO.createParameterList();

      // Set the import parameter
      input.appendValue("REQUTEXT", JCO.TYPE_CHAR, 255, "Simple JCO Test");

      // Create the out parameter list
      JCO.ParameterList output = JCO.createParameterList();

      // Specify the parameters types the function will be returning
      output.addInfo("ECHOTEXT", JCO.TYPE_CHAR, 255);
      output.addInfo("RESPTEXT", JCO.TYPE_CHAR, 255);

      // Call the RFC function
      myJcoclient.execute("STFC_CONNECTION", input, output);

      // Print the result
      System.out.println(
          "The RFC function 'STFC_CONNECTION' returned the following EXPORTS:\n" + 
             "---------------------------------------------------------------");
      for (int i = 0; i < output.getFieldCount(); i++) {
        System.out.println("Name: " +  output.getName(i) + 
                           " Value: " + output.getString(i)); 
      }

      // Close the connection
      myJcoclient.disconnect();
      return 1;

    } catch (Exception ex) {
      System.out.println("Caught an exception: \n" + ex);
      if (myJcoclient != null) {
        myJcoclient.disconnect();
      }
      return -1;
    }
  }

  public static void main (String[] argv){
    int retstat;
    TryJco myTryJco = new TryJco();
    retstat = myTryJco.doJco();
  }
}