package wrox.webservices;

import java.io.*;
import java.net.*;
import javax.ejb.CreateException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.ejb.SessionSynchronization;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.naming.InitialContext;
import org.w3c.dom.*;
import org.xml.sax.*;

public class StockQuoteServiceEJB implements SessionBean {
  private SessionContext context;

  // No argument constructor required by container.

  public StockQuoteServiceEJB() { }

  // Create method specified in EJB 2.0

  public void ejbCreate() { }

  // Methods required by SessionBean Interface. EJB 2.0

  public void setSessionContext(SessionContext context){
    this.context = context;
  }

  public void ejbActivate() { }

  public void ejbPassivate() { }

  public void ejbRemove() { }

  public String getQuote(String stocksymbols) {
    String quoteSource = "Yahoo";
    try {
      InitialContext ic = new InitialContext();
      quoteSource = (String) ic.lookup("java:/comp/env/QuoteSource");
      System.out.println("**** [StockQuoteService] Quote Source is " 
                         + quoteSource);
    } catch (Exception e) {
      e.printStackTrace();
    }

    if (quoteSource.equalsIgnoreCase("Yahoo")) {
      return getYahooQuotes(stocksymbols);
    } else if (quoteSource.equalsIgnoreCase("XML")) {
      return getXmlTodayQuotes(stocksymbols);
    } else {
      return "";
    }
  }

  private String getYahooQuotes(String stocksymbols) {
    String urlString = "http://quote.yahoo.com/d/quotes.csv?s=";
    java.util.StringTokenizer st = 
      new java.util.StringTokenizer(stocksymbols, " ");
    boolean first = true;
    while (st.hasMoreTokens()) {
      if (first) {
        urlString += st.nextToken().trim();
        first = false;
      } else {
        urlString += ("+" + st.nextToken().trim());
      }
    }
    urlString += "&f=sl1d1t1c1ohgvj1pp2owern&e=.csv";

    System.out.println("**** [StockQuoteService] URL: " + urlString);

    String response = "";
    String symbol = "";
    String quote = "";
    try {
      URL url = new URL(urlString);
      BufferedReader in =
        new BufferedReader(new InputStreamReader(url.openStream()));
      String s = null;
      while ((s = in.readLine()) != null) {
        s = s.trim();
        symbol = s.substring(1, s.indexOf("\"", 1));
        quote = s.substring(s.indexOf(",") + 1,
                            s.indexOf(",", s.indexOf(",") + 1));
        response += (symbol + "=" + quote + " ");
      }
      in.close();
    } catch (Exception e) {
      e.printStackTrace();
    }
    return response.trim();
  }

  private String getXmlTodayQuotes(String stocksymbols) {
    String urlString = 
      "http://www.xmltoday.com/examples/stockquote/getxmlquote.vep?s=";
    java.util.StringTokenizer st = 
      new java.util.StringTokenizer(stocksymbols, " ");
    boolean first = true;
    while (st.hasMoreTokens()) {
      if (first) {
        urlString += st.nextToken().trim();
        first = false;
      } else {
        urlString += ("+" + st.nextToken().trim());
      }
    }

    System.out.println("**** [StockQuoteService] URL: " + urlString);

    String response = "";
    String symbol = "";
    String quote = "";
    try {
      URL url = new URL(urlString);
      BufferedInputStream bis = new BufferedInputStream(url.openStream());

      DocumentBuilderFactory fact = DocumentBuilderFactory.newInstance();
      DocumentBuilder db = fact.newDocumentBuilder();
      Document doc = db.parse(new InputSource(bis));

      NodeList nodes = doc.getElementsByTagName("stock_quote");
      for (int i = 0; i < nodes.getLength(); i++) {
        NodeList nodes1 = nodes.item(i).getChildNodes();
        for (int j = 0; j < nodes1.getLength(); j++) {
          Node n = nodes1.item(j);
          if (n.getNodeType() != Node.ELEMENT_NODE) {
            continue;
          }
          Element e = (Element) n;
          if (e.getNodeName().equals("symbol")) {
            symbol = e.getFirstChild().getNodeValue();
          } else if (e.getNodeName().equals("price")
                     && e.getAttribute("type").equals("ask")) {
            quote = e.getAttribute("value");
          }
        }
        response += (symbol + "=" + quote + " ");
      }
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return response.trim();
  }
}