import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.encoding.BeanSerializer;
import org.apache.axis.encoding.XMLType;
import org.apache.axis.AxisFault;

import javax.xml.rpc.namespace.QName;

public class AxisClient4
{
   public static void main(String [] args) {

       try {
		   String endpointURL = "http://localhost:8070/axis/services/urn:greetingService1";

		   String methodName = "sayHello";

		   if(args.length<2) {
			   System.out.println("usage: java AxisClient <firstName> <lastName>");
			   System.exit(1);
		   }

 		   Service  service = new Service();

 		   //Create a Call object and set the parameterss
		   Call call    = (Call) service.createCall();
		   call.setTargetEndpointAddress(new java.net.URL(endpointURL));
		   call.setOperationName(methodName);
		   call.setProperty(Call.NAMESPACE,"urn:greetingService1");

           //Create the customer object to set first and last names
		   Customer customer = new Customer();
		   customer.setFirstName(args[0]);
		   customer.setLastName(args[1]);

		   // Register the Customer class
		   QName qn = new QName("urn:greetingService1","customer");
		   Class cls = Customer.class;
		   call.addSerializer(cls, qn, new org.apache.axis.encoding.BeanSerializer(cls));
 		   //call.addDeserializerFactory(qn, cls, BeanSerializer.getFactory());

		   // Set the input parameter to Call object
		   call.addParameter( "arg1", new XMLType(qn), Call.PARAM_MODE_IN );

		   //Invoke the service to get the response message as String object
		   String response = (String) call.invoke( new Object[] { customer } );
		   System.out.println("The Resonse:");
		   System.out.println(response);
        } catch (AxisFault fault) {
            System.out.println(fault.toString());
        }catch(Exception e){
		   System.out.println(e);
	     }
   }
}
