import java.io.*;
import java.util.Date;
import org.apache.axis.*;
import org.apache.axis.handlers.BasicHandler;

public class EventRecorder extends BasicHandler {

	static int count = 1;

    public void invoke(MessageContext msgContext) throws AxisFault
    {
        try {
			Handler serviceHandler = msgContext.getServiceHandler();
			String filename = (String)getOption("filename");
			if ((filename == null) || (filename.equals("")))
				throw new AxisFault("Server.NoLogFile",
								 "No log file configured for the LogHandler!",
									null, null);
			FileOutputStream fos = new FileOutputStream(filename, true);

			PrintWriter writer = new PrintWriter(fos);

			String logMsg = new Date()+": service "+
							msgContext.getTargetService() +
							" accessed " + count+ " time(s).";

			writer.println(logMsg);
			count++;
			writer.close();
		} catch (Exception e) {
			System.out.println(e);
		}
    }
    public void undo(MessageContext msgContext)
    {
    }
}
